package com.gct.aoid.controller;


import com.gct.aoid.entity.Vo.AbnormalDynamicVo;
import com.gct.aoid.service.AoidLiquidAbnormalDynamicService;
import com.gct.common.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 液量异常信息表(动态存储) 前端控制器
 * </p>
 *
 * @author gxt
 * @since 2022-08-15
 */
@RestController
@RequestMapping("/aoidLiquidAbnormalDynamic")
public class AoidLiquidAbnormalDynamicController {

    @Autowired
    AoidLiquidAbnormalDynamicService aoidLiquidAbnormalDynamicService;

    @PostMapping("/getAbnormalDynamicList")
    public Result getAbnormalDynamicList(@RequestBody AbnormalDynamicVo abnormalDynamicVo) {
        return Result.ok(aoidLiquidAbnormalDynamicService.getAbnormalDynamicList(abnormalDynamicVo));
    }

    @PostMapping("/areaLineChart")
    public Result areaLineChart(@RequestBody AbnormalDynamicVo abnormalDynamicVo) {
        return Result.ok(aoidLiquidAbnormalDynamicService.areaLineChart(abnormalDynamicVo));
    }
    @GetMapping("/areaLiqAlarm")
    public Result areaLiqAlarm(@RequestParam("orgId") String orgId){
        return Result.ok(aoidLiquidAbnormalDynamicService.areaLiqAlarm(orgId));
    }
}

