package com.gct.aoid.entity.MQ;

import io.swagger.annotations.ApiModel;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * class name: BaseParam
 *
 * @author gxt
 * @version 1.0
 * @since 2022/9/23 下午2:05 周五
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="BaseParam", description="诊断基础数据对象")
public class BaseParam {
    private Double sAtSlopeMinLoc;
    private Double sAtSlopeMaxLoc;
    private Double slopeDownloadMin;
    private Double slopeDownloadMax;

    private String id;

    private LocalDateTime createtime;

    private LocalDateTime prodDate;

    private String wellname;

    private String wellId;

    private String sgt;

    private double sMax;

    private double sMin;

    private Double lMax;

    private Double lMin;

    private double s;

    private double n;

    private double l;

    private double sEffect;

    private double area;

    private double upload;

    private double download;

    private Integer islegal;

    private String remark;

    private double lMid;

    private double lFirstdownturnpoint;

    private double sPre;

    private Integer sgtpointnum;

    private Integer sMaxPointLocation;

    private Integer sMinPointLocation;

    private Integer lMaxPointLocation;

    private Integer lMinPointLocation;
}
