package com.gct.aoid.entity.Vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * class name: AbnormalDynamicVo
 *
 * @author gxt
 * @version 1.0
 * @since 2022/8/16 下午5:21 周二
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "AbnormalDynamicVo对象", description = "动态液量数据请求对象")
public class AbnormalDynamicVo {
    private String wellId;
    private List<String> wellIds;
    private String orgName;
    private String orgId;
    private String startDate;
    private String endDate;
    private Integer currentPage;
    private Integer pageSize;
    @ApiModelProperty(value = "前端筛选的条件,字段名和筛选规则用逗号隔开")
    private String columnFilter;
    @ApiModelProperty(value = "前端筛选的条件,头部的条件过滤,用来筛选全部")
    private String headFilter;
}
