package com.gct.aoid.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.aoid.entity.AoidLiquidAbnormalDynamic;
import com.gct.aoid.entity.Vo.AbnormalDynamicVo;

import java.time.LocalDateTime;
import java.util.Map;

/**
 * <p>
 * 液量异常信息表(动态存储) 服务类
 * </p>
 *
 * @author gxt
 * @since 2022-08-15
 */
public interface AoidLiquidAbnormalDynamicService extends IService<AoidLiquidAbnormalDynamic> {

    void saveLiquidAbnormalList(LocalDateTime date);

    Page<AoidLiquidAbnormalDynamic> getAbnormalDynamicList(AbnormalDynamicVo abnormalDynamicVo);

    Map<String, Object> areaLineChart(AbnormalDynamicVo abnormalDynamicVo);

    Map<String, Object> areaLiqAlarm(String orgId);
}
