package com.gct.aoid.algorithm;

import com.gct.aoid.ProductionCalApplication;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.aoid.service.AoidSinglegtYieldService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.lang.reflect.InvocationTargetException;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
public class CalGTCorrectTestwsyhss {
    @Autowired
    private com.gct.aoid.service.impl.calDiagramProductionCorrectService calDiagramProductionCorrectService;



    @Autowired
    AoidSinglegtYieldService aoidSinglegtYieldService;
    @Autowired
    private AoidDailyYieldService aoidDailyYieldService;

    @Autowired
    private BaseDataClient baseDataClient;

    /**
     * 量液修正
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     * @throws InstantiationException
     * @throws NoSuchMethodException
     */
    @Test
    public  void test3() throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException, ParseException {
//        String allRuntimeData = baseDataClient.getAllRuntimeData();
//        Result result = JSONObject.parseObject(allRuntimeData, Result.class);
//        Object data = result.getData();
//        JSONArray jsonArray = JSONArray.parseArray(data.toString());
//        System.out.println("要进行"+jsonArray.size());
//        int count =0;
//        for (int i = 0; i < jsonArray.size(); i++) {
//            JSONObject jo = jsonArray.getJSONObject(i);
//            String wellId = jo.getString("wellId");
//            List<AoidSinglegtYield> ss = aoidSinglegtYieldService.getAoidSinglegtYieldInfogk(wellId);
//            if (ss.size()>1)
//            {
//                System.out.println("井号："+wellId+"次数："+ss.size());
//                System.out.println("筛选出"+count++);
//            }
//        }
//        String wellId="h0556";
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//        Date date_start = new Date(new Date().getTime()-24*60*60*1000);
//        Date date_end = new Date(new Date().getTime());
//        String time_start = "2021-11-04";
//        String time_end = "2021-11-04";
//        String time_start1 = time_start+" 00:00:00";
//        String time_end1 = time_end+" 23:59:59";
//        List<AoidDailyYield> resultAoidDailyYield = aoidDailyYieldService.findByJhAoidDaily(wellId,time_start1,time_end1);

//        double ss =   32.5;
//        double ff =   27.26;
//        double wc = 0;
//        wc =round2(100*abs(ff,ss)/ff);
////        BigDecimal bg = new BigDecimal(wc);
////        double wcl =bg.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
//
//
//        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//        Date date_start = new Date(new Date().getTime()-48*60*60*1000);
//        String time_start = sdf.format(date_start);
//        String datetime_now = time_start+" 00:00:00.000";
//        System.out.println(datetime_now);

//        String data[] = new String[24];
//
//        data[0] = "0,4352,0,4359,1,4365,2,4373,3,4379,4,4393,6,4404,8,4417,10,4429,12,4441,15,4457,18,4475,21,4492,25,4511,28,4541,33,4558,37,4583,41,4614,46,4654,52,4699,57,4749,62,4797,68,4840,73,4876,79,4896,84,4905,90,4904,95,4889,100,4858,106,4819,111,4787,117,4771,122,4767,128,4775,133,4787,138,4808,144,4840,149,4865,155,4884,160,4887,166,4878,171,4863,176,4843,182,4816,187,4794,193,4775,198,4767,204,4775,209,4788,214,4805,220,4827,225,4846,231,4858,236,4864,242,4858,247,4842,252,4824,258,4806,263,4783,269,4767,274,4756,280,4753,285,4753,290,4762,296,4772,301,4781,307,4787,312,4785,318,4778,323,4764,329,4740,334,4710,339,4684,345,4657,350,4633,356,4615,361,4605,367,4604,372,4612,377,4615,383,4618,388,4617,394,4613,399,4603,404,4587,410,4567,415,4540,421,4519,425,4503,430,4492,434,4488,438,4485,442,4484,446,4483,449,4480,452,4482,455,4486,457,4490,459,4494,461,4501,463,4506,464,4512,465,4514,466,4511,467,4505,467,4498,467,4491,467,4483,466,4474,465,4467,464,4458,463,4436,461,4417,459,4394,457,4382,455,4361,452,4316,449,4258,446,4193,442,4123,438,4063,434,4011,430,3962,425,3969,421,4009,415,4072,410,4144,404,4209,398,4255,392,4293,387,4301,381,4270,375,4217,370,4151,364,4085,358,4046,353,4025,347,4018,341,4050,336,4101,330,4166,324,4232,319,4281,313,4306,307,4313,301,4300,296,4267,290,4224,284,4181,279,4138,273,4119,267,4118,262,4131,256,4161,250,4194,245,4230,239,4267,233,4293,227,4303,222,4299,216,4278,210,4251,205,4229,199,4205,193,4185,188,4184,182,4190,176,4212,171,4249,165,4279,159,4307,153,4332,148,4344,142,4342,136,4338,131,4325,125,4305,119,4290,114,4282,108,4276,102,4289,97,4307,91,4322,85,4346,80,4368,74,4384,68,4394,63,4396,57,4388,51,4380,46,4373,40,4367,34,4359,28,4354,23,4349,17,4347,11,4345,6,4344,0,4346,0,4351";
//        data[1] = "0,4347,0,4352,1,4362,2,4371,3,4384,5,4397,7,4411,9,4425,11,4440,14,4452,17,4455,21,4474,25,4490,29,4507,33,4528,38,4551,43,4572,48,4602,54,4641,60,4685,67,4733,73,4780,79,4827,85,4867,92,4889,98,4899,104,4901,111,4891,117,4872,124,4836,130,4807,136,4781,143,4770,149,4772,155,4781,161,4797,168,4821,174,4850,180,4874,187,4885,193,4883,200,4868,206,4853,212,4835,219,4809,225,4788,231,4775,238,4770,244,4781,250,4796,256,4812,263,4831,269,4845,275,4854,282,4857,288,4852,294,4835,301,4818,307,4801,313,4781,320,4769,326,4763,333,4756,339,4761,345,4770,352,4780,358,4790,364,4790,371,4785,377,4773,383,4757,390,4733,396,4703,402,4674,408,4650,414,4629,419,4616,424,4610,429,4608,434,4608,438,4612,442,4611,445,4608,448,4602,451,4585,454,4565,456,4545,458,4529,459,4510,461,4496,461,4485,462,4481,462,4482,462,4484,462,4484,461,4489,461,4492,459,4497,458,4499,456,4501,454,4504,451,4506,448,4507,445,4505,442,4503,438,4498,434,4494,429,4486,424,4479,419,4471,414,4460,408,4441,402,4426,398,4408,393,4397,388,4388,383,4353,379,4297,374,4231,369,4160,365,4087,360,4033,355,3969,351,3946,346,3978,341,4039,337,4116,332,4192,327,4244,323,4288,318,4322,313,4302,309,4254,304,4187,299,4112,294,4060,290,4035,285,4020,281,4036,276,4080,271,4137,267,4207,262,4272,257,4306,252,4318,248,4317,243,4290,238,4250,234,4205,229,4157,224,4123,220,4116,215,4120,210,4144,206,4174,201,4216,196,4255,192,4291,187,4310,182,4310,178,4297,173,4270,168,4246,164,4222,159,4200,154,4185,150,4191,145,4206,140,4238,136,4270,131,4298,126,4326,122,4351,117,4358,112,4352,107,4336,103,4319,98,4301,93,4288,89,4274,84,4273,80,4289,75,4309,70,4331,65,4354,61,4372,56,4387,51,4400,47,4399,42,4388,37,4375,33,4369,28,4362,23,4357,19,4354,14,4352,9,4350,5,4349,0,4347,0,4346";
//        data[2] = "0,2039,0,2053,1,2064,1,2077,2,2086,3,2104,4,2115,6,2127,7,2135,9,2144,11,2153,13,2165,16,2177,18,2187,21,2211,24,2230,28,2249,31,2271,35,2293,39,2314,42,2335,47,2354,51,2373,55,2390,59,2415,63,2423,67,2436,71,2446,75,2452,79,2452,83,2454,87,2453,91,2451,95,2448,99,2448,103,2449,107,2451,111,2451,115,2452,120,2456,124,2456,128,2457,132,2459,136,2457,140,2455,144,2455,148,2453,152,2450,156,2444,160,2443,164,2439,168,2438,172,2437,176,2434,180,2432,184,2431,188,2432,192,2429,196,2429,200,2426,204,2422,208,2421,213,2416,217,2413,221,2408,225,2403,229,2399,233,2398,237,2396,241,2391,245,2388,249,2384,253,2382,256,2378,260,2376,263,2374,266,2373,269,2369,272,2366,274,2364,276,2359,278,2356,280,2352,282,2347,283,2338,285,2331,285,2322,286,2299,287,2290,287,2280,288,2269,288,2258,287,2245,287,2233,286,2222,285,2211,285,2187,283,2180,282,2173,280,2163,278,2159,276,2154,274,2146,272,2140,269,2136,266,2128,263,2122,260,2117,256,2110,253,2102,249,2093,246,2084,243,2076,240,2069,238,2047,235,2052,232,2039,229,2024,226,2011,223,1995,221,1979,218,1965,215,1951,212,1938,209,1922,206,1916,204,1913,201,1911,198,1909,195,1908,192,1908,190,1912,187,1915,184,1919,181,1923,178,1928,175,1931,173,1935,170,1939,167,1938,164,1940,161,1941,158,1942,156,1942,153,1942,150,1944,147,1948,144,1950,141,1951,139,1950,136,1950,133,1945,130,1942,127,1940,125,1936,122,1933,119,1933,116,1931,113,1929,110,1925,107,1925,105,1926,102,1926,99,1925,96,1924,93,1926,91,1924,88,1921,85,1920,82,1914,79,1913,76,1909,73,1909,71,1905,68,1903,65,1900,62,1899,59,1895,57,1893,54,1892,51,1892,48,1890,45,1886,42,1881,40,1880,37,1880,34,1878,31,1881,28,1885,25,1889,23,1898,20,1905,17,1915,14,1927,11,1937,8,1950,6,1986,3,1999,0,2014,0,2028";
//        data[3] = "0,2066,0,2080,1,2091,1,2101,2,2120,3,2129,4,2137,6,2145,7,2152,9,2163,11,2175,14,2182,16,2190,19,2219,22,2211,25,2228,28,2245,32,2267,35,2288,39,2308,43,2331,47,2353,52,2374,56,2405,60,2416,64,2424,68,2437,72,2445,76,2450,80,2452,84,2452,89,2452,93,2448,97,2444,101,2441,105,2441,109,2441,113,2441,118,2442,122,2446,126,2447,130,2448,134,2450,138,2451,142,2448,146,2448,150,2447,155,2445,159,2441,163,2438,167,2435,171,2433,175,2429,179,2429,183,2428,188,2427,192,2425,196,2422,200,2422,204,2416,208,2411,212,2409,216,2404,221,2401,225,2397,229,2394,233,2393,237,2389,241,2385,245,2385,249,2384,253,2381,257,2381,260,2379,264,2379,267,2375,270,2374,272,2367,275,2363,277,2360,279,2354,281,2351,283,2347,284,2340,285,2331,286,2322,287,2299,288,2289,288,2280,288,2270,288,2261,288,2250,288,2240,287,2229,286,2219,285,2196,284,2186,283,2176,281,2169,279,2164,277,2158,275,2150,272,2145,270,2138,267,2128,264,2124,260,2117,257,2112,253,2108,249,2101,246,2092,244,2084,241,2076,238,2057,235,2048,232,2039,230,2027,227,2013,224,1996,221,1982,218,1971,216,1959,213,1946,210,1933,207,1928,204,1925,202,1922,199,1921,196,1918,193,1918,190,1919,188,1923,185,1929,182,1931,179,1933,176,1938,174,1939,171,1939,168,1940,165,1940,162,1940,160,1939,157,1938,154,1939,151,1939,149,1941,146,1939,143,1940,140,1939,137,1939,134,1937,132,1936,129,1934,126,1934,123,1931,120,1932,118,1931,115,1928,112,1927,109,1928,106,1927,104,1926,101,1925,98,1923,95,1922,92,1919,90,1917,87,1913,84,1908,81,1904,78,1902,76,1900,73,1897,70,1893,67,1891,64,1890,62,1886,59,1884,56,1885,53,1883,50,1880,48,1875,45,1871,42,1870,39,1869,36,1865,34,1867,31,1870,28,1875,25,1882,22,1891,20,1903,17,1913,14,1929,11,1946,8,1986,6,2002,3,2018,0,2036,0,2051";
//        data[4] = "0,3284,0,3295,0,3298,1,3301,1,3303,1,3301,2,3298,3,3295,4,3292,4,3288,6,3283,7,3273,8,3269,9,3266,11,3261,12,3258,14,3258,15,3258,17,3259,19,3261,21,3262,23,3263,25,3262,27,3262,29,3261,31,3258,33,3256,35,3252,37,3249,39,3241,41,3237,43,3231,45,3228,47,3226,49,3222,51,3218,53,3214,55,3211,57,3209,59,3205,61,3203,63,3201,65,3200,67,3200,69,3198,71,3197,73,3194,76,3191,78,3188,80,3181,81,3176,83,3170,85,3166,88,3162,90,3159,92,3153,94,3150,96,3149,98,3148,100,3148,102,3149,104,3149,106,3148,108,3147,110,3147,112,3147,114,3148,116,3148,118,3148,120,3147,122,3147,124,3143,126,3140,127,3137,129,3133,131,3131,132,3126,134,3124,135,3122,136,3118,137,3115,138,3112,139,3108,140,3104,141,3097,141,3088,142,3077,142,3070,143,3063,143,3047,143,3034,143,3019,143,3010,143,3002,142,2984,142,2960,141,2932,141,2915,140,2899,139,2863,138,2828,137,2797,136,2783,135,2770,134,2747,132,2726,131,2706,129,2698,127,2691,126,2678,124,2669,122,2662,121,2657,120,2653,118,2651,117,2653,115,2657,114,2660,112,2664,111,2670,110,2675,108,2677,107,2676,105,2676,104,2676,103,2679,101,2677,100,2676,98,2675,97,2673,96,2670,94,2670,93,2670,91,2671,90,2673,89,2677,87,2683,86,2685,84,2688,83,2693,82,2697,80,2702,79,2703,77,2705,76,2709,74,2716,73,2720,72,2720,70,2721,69,2726,68,2731,66,2736,65,2740,63,2744,62,2751,60,2759,59,2769,58,2774,56,2779,55,2790,53,2801,52,2813,51,2817,49,2821,48,2827,46,2835,45,2841,44,2843,42,2845,41,2850,39,2855,38,2856,36,2856,35,2857,34,2859,32,2861,31,2866,29,2865,28,2865,27,2869,25,2878,24,2887,23,2894,21,2901,20,2921,18,2944,17,2970,15,2984,14,2999,13,3030,11,3059,10,3092,8,3110,7,3128,6,3162,4,3195,3,3222,1,3234,0,3246,0,3267";
//        data[5] = "0,3286,0,3300,0,3308,1,3311,1,3311,2,3311,2,3307,3,3304,4,3298,5,3295,6,3292,7,3283,8,3276,10,3270,11,3269,13,3268,14,3267,16,3267,18,3266,20,3266,22,3266,24,3266,26,3265,28,3263,30,3263,33,3263,35,3259,37,3254,39,3248,41,3244,43,3240,45,3233,47,3227,49,3221,52,3220,54,3219,56,3217,58,3216,60,3212,62,3212,64,3213,66,3215,68,3215,70,3214,72,3213,75,3212,77,3208,79,3202,81,3195,83,3191,85,3187,87,3183,89,3178,91,3169,94,3166,96,3163,98,3157,100,3156,102,3151,104,3149,106,3148,108,3148,110,3148,112,3149,115,3148,117,3148,119,3150,121,3151,123,3152,125,3152,127,3152,129,3147,130,3142,132,3138,133,3135,135,3133,136,3128,137,3126,138,3121,139,3119,140,3117,141,3113,141,3106,142,3099,142,3093,143,3088,143,3076,143,3060,143,3043,143,3036,143,3030,142,3015,142,2997,141,2979,141,2967,140,2956,139,2926,138,2892,137,2858,136,2839,135,2821,133,2792,132,2764,130,2743,129,2732,127,2722,125,2706,123,2691,122,2680,120,2676,119,2672,118,2663,116,2656,115,2653,114,2653,112,2653,111,2659,109,2663,108,2667,107,2668,105,2670,104,2672,103,2671,101,2673,100,2673,99,2674,97,2674,96,2672,95,2670,93,2669,92,2669,91,2668,89,2667,88,2670,86,2672,85,2674,84,2679,82,2685,81,2688,80,2690,78,2693,77,2696,76,2699,74,2700,73,2701,72,2703,70,2705,69,2709,68,2711,66,2712,65,2713,64,2720,62,2728,61,2736,59,2739,58,2743,57,2751,55,2761,54,2770,53,2776,51,2783,50,2793,49,2804,47,2811,46,2814,45,2818,43,2822,42,2829,41,2837,39,2838,38,2840,36,2842,35,2842,34,2844,32,2845,31,2847,30,2850,28,2857,27,2864,26,2865,24,2867,23,2877,22,2889,20,2907,19,2918,17,2930,16,2955,15,2984,14,3014,12,3031,11,3048,10,3083,8,3123,7,3161,5,3177,4,3194,3,3223,1,3247,0,3267,0,3276";
//        data[6] = "0,2635,0,2643,1,2656,1,2667,2,2695,2,2711,3,2745,4,2769,6,2823,7,2855,9,2922,10,2957,12,3019,14,3041,16,3070,19,3078,21,3086,24,3088,27,3096,29,3094,33,3091,36,3087,39,3080,42,3078,45,3073,48,3072,51,3072,54,3071,57,3069,61,3069,64,3068,67,3068,70,3062,73,3060,76,3058,79,3056,82,3057,85,3058,89,3057,92,3054,95,3050,98,3048,101,3045,104,3042,107,3042,110,3045,113,3047,117,3045,120,3043,123,3042,126,3036,129,3030,132,3018,135,3013,138,3003,141,2991,145,2973,148,2967,151,2952,154,2943,157,2925,160,2920,163,2910,166,2907,169,2904,172,2910,175,2919,179,2920,182,2926,185,2928,188,2929,191,2930,194,2935,197,2938,200,2941,204,2940,207,2938,210,2940,213,2934,216,2933,219,2937,222,2937,225,2935,228,2933,231,2933,235,2933,238,2933,241,2932,244,2933,246,2934,249,2933,252,2933,254,2934,256,2935,258,2937,260,2937,262,2941,263,2939,265,2934,266,2930,267,2919,268,2912,269,2914,269,2909,270,2902,270,2898,270,2890,270,2883,270,2876,270,2875,269,2871,269,2871,268,2867,267,2866,266,2859,265,2857,263,2855,262,2854,260,2851,258,2850,256,2847,254,2846,252,2844,249,2841,246,2841,244,2840,241,2837,237,2837,234,2829,231,2825,227,2819,224,2814,221,2800,217,2793,214,2778,211,2771,207,2754,204,2748,201,2737,197,2731,194,2715,191,2708,187,2699,184,2693,181,2685,177,2681,174,2656,171,2645,167,2621,164,2608,160,2575,157,2560,154,2536,150,2526,147,2511,144,2506,140,2511,137,2508,134,2505,130,2503,127,2508,124,2510,120,2513,117,2517,114,2521,110,2522,107,2523,104,2523,100,2524,97,2527,94,2527,90,2531,87,2534,84,2537,80,2540,77,2544,74,2545,70,2548,67,2554,64,2555,60,2563,57,2564,53,2570,50,2572,47,2575,43,2574,40,2581,37,2584,33,2585,30,2587,27,2592,23,2593,20,2600,17,2601,13,2603,10,2604,7,2603,3,2605,0,2620,0,2627";
//        data[7] = "0,2652,0,2660,1,2670,1,2682,2,2700,2,2738,3,2760,4,2807,6,2836,7,2892,9,2919,11,2969,13,2990,15,3019,17,3025,19,3029,22,3028,25,3033,28,3032,31,3029,34,3028,37,3023,41,3022,44,3020,47,3019,50,3022,53,3021,57,3018,60,3017,63,3016,66,3012,70,3012,73,3011,76,3013,79,3013,83,3013,86,3015,89,3015,92,3013,95,3008,99,3007,102,3002,105,2998,108,2996,112,2996,115,2994,118,2994,121,2990,125,2989,128,2987,131,2986,134,2984,138,2982,141,2972,144,2965,147,2953,151,2946,154,2929,157,2919,160,2899,164,2888,167,2872,170,2866,173,2861,176,2860,180,2860,183,2859,186,2862,190,2867,193,2872,196,2876,199,2881,202,2885,206,2890,209,2895,212,2899,215,2900,219,2900,222,2900,225,2900,228,2898,232,2897,235,2897,238,2894,241,2892,244,2886,247,2886,249,2889,252,2887,254,2884,256,2883,258,2881,260,2881,262,2882,263,2882,264,2890,265,2892,266,2886,267,2882,268,2872,268,2868,269,2864,269,2859,269,2856,269,2850,268,2841,268,2836,267,2823,266,2820,265,2812,264,2807,263,2801,262,2800,260,2800,258,2799,256,2796,254,2796,252,2795,249,2792,247,2793,244,2792,241,2789,238,2789,235,2786,232,2783,229,2780,225,2779,222,2775,219,2774,216,2769,213,2766,210,2755,207,2749,204,2734,200,2728,197,2712,194,2705,191,2686,188,2677,185,2656,182,2644,178,2625,175,2617,172,2595,169,2584,166,2562,163,2554,160,2541,157,2536,153,2528,150,2530,147,2532,144,2529,141,2531,138,2532,135,2537,131,2538,128,2538,125,2539,122,2544,119,2540,116,2539,113,2542,109,2543,106,2547,103,2548,100,2550,97,2554,94,2556,91,2557,88,2559,84,2562,81,2563,78,2569,75,2570,72,2577,69,2581,66,2586,63,2587,59,2591,56,2593,53,2598,50,2600,47,2603,44,2606,41,2609,38,2613,34,2618,31,2620,28,2625,25,2625,22,2626,19,2626,16,2628,12,2631,9,2632,6,2630,3,2635,0,2642,0,2648";
//        data[8] = "0,2131,0,2134,1,2139,1,2142,2,2148,3,2152,4,2154,6,2156,8,2163,10,2164,12,2171,14,2174,16,2190,19,2202,22,2215,25,2234,29,2251,32,2266,36,2285,40,2302,44,2335,48,2350,53,2378,57,2390,61,2407,65,2414,70,2413,74,2409,78,2404,82,2403,86,2399,91,2398,95,2398,99,2397,103,2399,107,2396,112,2398,116,2398,120,2398,124,2398,129,2396,133,2395,137,2390,141,2389,146,2382,150,2380,154,2380,158,2379,162,2380,167,2376,171,2376,175,2375,179,2377,183,2376,188,2376,192,2375,196,2369,200,2367,204,2365,209,2365,213,2362,217,2359,221,2357,226,2356,230,2352,234,2351,238,2349,242,2347,245,2344,249,2343,252,2340,255,2338,258,2335,260,2334,262,2331,265,2328,267,2326,268,2327,270,2321,271,2317,272,2315,273,2315,273,2308,274,2308,274,2307,274,2306,274,2303,273,2300,273,2300,272,2301,271,2297,270,2293,268,2290,267,2287,265,2280,262,2280,260,2275,258,2276,255,2272,252,2271,249,2268,245,2268,242,2264,238,2261,234,2255,231,2252,229,2247,227,2244,224,2235,221,2230,219,2225,217,2218,214,2202,212,2195,209,2176,207,2168,204,2156,202,2144,199,2138,197,2124,194,2097,192,2086,189,2068,187,2061,184,2051,182,2047,179,2042,177,2043,174,2043,172,2045,169,2049,167,2049,164,2044,162,2043,159,2042,157,2042,154,2041,152,2039,149,2038,147,2036,144,2036,142,2038,139,2040,137,2043,134,2042,132,2039,129,2037,127,2035,124,2033,122,2032,119,2030,117,2029,115,2026,112,2024,109,2024,107,2025,104,2024,102,2024,99,2023,97,2024,95,2022,92,2022,90,2023,87,2023,84,2022,82,2022,80,2021,77,2020,75,2020,72,2021,70,2021,67,2021,65,2021,62,2022,60,2023,57,2025,55,2028,52,2031,50,2033,47,2034,45,2036,42,2040,40,2042,37,2044,35,2051,32,2051,30,2058,27,2060,25,2068,22,2073,20,2081,17,2085,15,2097,12,2099,10,2103,7,2107,5,2115,2,2119,0,2122,0,2126";
//        data[9] = "0,2132,0,2134,1,2141,1,2143,2,2150,3,2152,4,2157,6,2160,7,2166,9,2168,11,2169,14,2172,16,2187,19,2200,22,2210,25,2219,28,2235,32,2250,36,2267,40,2283,44,2316,48,2333,52,2368,56,2383,60,2400,65,2405,69,2413,73,2413,77,2408,81,2407,85,2406,90,2403,94,2397,98,2395,102,2396,106,2396,110,2398,114,2397,119,2400,123,2398,127,2398,131,2396,135,2396,139,2395,144,2394,148,2391,152,2388,156,2387,160,2385,164,2386,169,2382,173,2383,177,2380,181,2378,185,2374,189,2371,194,2371,198,2370,202,2365,206,2362,210,2358,214,2357,219,2355,223,2354,227,2351,231,2352,235,2343,239,2342,242,2338,246,2337,249,2333,252,2330,254,2325,257,2327,259,2326,261,2324,263,2324,265,2324,266,2321,267,2318,268,2316,269,2315,270,2312,270,2310,271,2304,271,2303,270,2302,270,2301,269,2298,268,2297,267,2295,266,2292,265,2286,263,2282,261,2279,259,2277,257,2271,254,2268,252,2265,249,2266,246,2263,242,2264,239,2263,235,2261,231,2258,229,2254,226,2246,224,2244,221,2237,219,2232,216,2224,214,2218,211,2202,209,2195,206,2187,204,2177,201,2169,199,2159,197,2160,194,2148,192,2122,189,2111,187,2090,184,2082,182,2068,179,2063,177,2055,174,2052,172,2049,170,2049,167,2050,165,2047,162,2047,160,2045,157,2045,155,2045,152,2043,150,2042,147,2042,145,2042,142,2043,140,2042,138,2040,135,2039,133,2035,130,2035,128,2035,125,2035,123,2033,120,2033,118,2031,116,2033,113,2031,110,2031,108,2032,106,2031,103,2030,101,2027,98,2029,96,2029,93,2026,91,2025,88,2026,86,2026,83,2028,81,2026,79,2023,76,2024,74,2021,71,2020,69,2020,66,2018,64,2017,61,2018,59,2015,56,2018,54,2021,52,2022,49,2025,47,2025,44,2029,42,2031,39,2036,37,2038,34,2046,32,2048,29,2055,27,2059,25,2066,22,2070,20,2079,17,2084,15,2089,12,2094,10,2102,7,2107,5,2114,2,2116,0,2121,0,2124";
//        data[10] = "0,5404,0,5456,0,5491,1,5513,1,5548,2,5582,3,5608,4,5621,5,5652,7,5712,8,5790,10,5864,13,5929,15,5973,17,6059,20,6129,23,6198,26,6263,29,6354,33,6467,36,6589,41,6680,45,6775,49,6853,53,6975,57,7061,62,7105,67,7057,72,6992,77,6923,83,6849,88,6788,93,6732,99,6675,104,6662,111,6636,117,6680,123,6723,129,6779,136,6836,142,6849,148,6871,154,6879,160,6871,168,6871,175,6818,181,6779,187,6740,195,6693,202,6688,209,6693,215,6697,222,6723,230,6732,237,6758,244,6775,250,6797,257,6814,265,6810,272,6801,278,6766,285,6740,293,6727,300,6710,306,6675,313,6675,319,6662,327,6662,333,6671,340,6693,346,6710,353,6714,359,6727,365,6727,371,6723,377,6714,383,6719,389,6701,394,6684,400,6649,406,6645,411,6606,416,6610,420,6606,425,6615,430,6619,434,6619,438,6628,442,6641,446,6645,450,6641,453,6628,456,6610,458,6593,461,6580,463,6550,465,6528,467,6515,468,6515,470,6519,470,6471,471,6419,471,6337,471,6289,470,6237,470,6181,468,6116,467,6077,465,6033,463,5973,461,5899,458,5842,455,5721,452,5608,448,5508,445,5370,441,5292,436,5253,431,5174,426,4992,422,4862,416,4780,410,4654,405,4637,399,4719,393,4819,385,4914,379,4984,373,5070,366,5140,358,5166,351,5174,343,5179,336,5140,329,5096,320,5027,312,4971,305,4966,298,4884,289,4767,282,4762,275,4810,268,4901,260,4962,252,4979,245,4966,238,4958,231,4971,224,5049,215,5070,208,5070,201,5062,194,5010,186,4966,179,4966,173,4971,167,4966,160,4979,153,5001,147,5001,141,4966,135,5010,128,5062,122,5075,116,5101,111,5122,105,5101,99,5083,94,5079,89,5105,84,5096,78,5079,73,5057,69,5066,64,5066,60,5083,55,5109,51,5127,47,5135,43,5140,39,5153,36,5179,32,5187,29,5187,26,5192,23,5187,20,5183,18,5161,15,5170,13,5174,11,5183,9,5187,7,5196,6,5209,4,5227,3,5248,2,5287,1,5300,1,5344,0,5374";
//        data[11] = "0,5322,0,5365,0,5400,0,5448,1,5487,1,5508,2,5556,3,5565,4,5565,5,5613,7,5665,9,5725,11,5803,13,5882,15,5942,17,6016,21,6094,23,6163,26,6250,29,6333,34,6424,37,6532,41,6645,45,6740,49,6844,54,6936,58,7048,62,7157,68,7126,73,7087,77,7018,82,6936,88,6875,94,6801,99,6740,105,6714,111,6667,118,6701,123,6732,129,6784,135,6844,143,6884,149,6905,155,6936,161,6923,169,6923,175,6888,181,6862,188,6814,195,6771,202,6749,209,6740,216,6740,223,6766,230,6766,237,6797,244,6818,250,6844,259,6853,265,6858,272,6844,279,6836,286,6805,293,6788,300,6762,306,6723,313,6714,320,6719,327,6710,333,6714,339,6719,347,6736,353,6745,359,6766,365,6775,372,6775,377,6762,383,6766,389,6745,395,6727,400,6697,405,6688,410,6649,415,6645,421,6632,425,6632,430,6632,434,6649,439,6645,442,6662,446,6658,449,6662,453,6658,456,6641,458,6628,461,6610,463,6571,465,6541,467,6537,468,6528,469,6537,470,6419,471,6415,471,6328,470,6263,470,6211,469,6150,468,6081,467,6055,465,5994,463,5921,460,5864,458,5747,454,5617,451,5504,448,5404,444,5283,440,5240,435,5157,431,5001,426,4884,422,4819,416,4684,410,4532,405,4567,399,4663,392,4741,386,4814,379,4936,373,5023,366,5040,358,5083,351,5135,344,5109,338,5066,329,4992,322,4906,315,4784,308,4719,299,4710,292,4697,285,4697,278,4732,269,4771,262,4836,255,4901,248,4962,240,4997,232,4988,225,4979,218,4958,211,4949,202,4949,195,4923,188,4862,182,4836,174,4823,168,4832,161,4866,155,4897,148,4927,142,4962,135,4984,129,5001,124,5005,117,5031,111,5044,106,5027,100,5018,94,5018,89,4992,84,4958,79,4962,74,4979,69,4988,65,4988,60,5014,55,5036,51,5044,47,5066,44,5101,40,5122,36,5114,33,5118,29,5114,26,5114,23,5101,20,5101,18,5096,15,5092,13,5092,11,5118,9,5148,7,5157,6,5170,4,5200,3,5218,2,5235,1,5257,1,5296";
//        data[12] = "0,954,0,958,0,980,0,1049,1,1088,1,1123,1,1114,2,1092,3,1075,4,1088,4,1092,5,1110,7,1110,8,1118,9,1097,10,1114,12,1114,12,1114,14,1105,16,1114,17,1105,19,1101,21,1097,23,1114,25,1123,27,1105,29,1118,31,1105,34,1110,36,1118,39,1114,41,1110,44,1105,46,1114,48,1110,51,1123,54,1127,56,1131,59,1118,62,1123,65,1114,68,1118,71,1118,74,1118,77,1127,80,1110,83,1123,87,1118,90,1118,93,1123,95,1114,99,1114,102,1110,105,1097,109,1118,112,1092,116,1110,119,1092,122,1097,126,1097,129,1105,133,1084,136,1097,140,1075,144,1088,147,1075,151,1075,153,1075,157,1062,161,1075,164,1062,168,1062,172,1058,176,1053,179,1053,183,1062,187,1045,191,1053,195,1040,199,1049,202,1045,206,1040,210,1045,214,1045,217,1045,221,1058,225,1032,229,1062,232,1045,235,1049,238,1053,241,1058,244,1058,246,1066,248,1066,249,1066,251,1058,252,949,253,819,255,810,256,806,257,819,258,836,260,849,261,828,261,728,261,724,261,732,259,789,257,797,255,780,252,750,248,737,245,758,241,784,237,802,232,784,229,784,225,767,221,789,216,802,212,810,208,793,203,784,199,771,195,797,190,810,186,802,182,802,178,793,174,793,170,806,165,802,161,789,158,793,154,789,150,802,147,802,143,806,139,797,135,806,131,789,127,802,123,806,119,797,116,789,112,797,108,793,105,802,101,802,99,797,95,797,92,797,88,810,85,797,82,806,78,793,75,797,72,806,69,793,66,806,63,802,60,797,57,819,54,802,51,819,48,806,47,806,44,793,41,806,39,810,37,806,34,810,32,810,30,823,28,810,25,815,23,806,21,815,20,823,18,819,16,819,14,815,13,810,12,815,10,819,9,823,8,810,7,819,6,806,5,815,4,819,3,802,3,815,2,797,1,802,1,802,1,793,0,797,0,919";
//        data[13] = "0,949,0,975,0,1049,0,1079,1,1110,1,1101,2,1088,3,1075,4,1088,5,1097,6,1118,7,1105,8,1105,10,1097,12,1105,13,1105,15,1110,17,1105,19,1105,21,1097,24,1105,26,1092,29,1105,31,1118,34,1110,37,1114,39,1097,41,1105,44,1105,47,1114,50,1110,54,1092,57,1114,60,1110,63,1123,66,1118,70,1127,73,1114,76,1123,80,1105,83,1118,85,1105,89,1118,92,1118,95,1118,99,1118,102,1105,106,1118,109,1105,113,1110,116,1101,119,1101,123,1092,126,1114,129,1092,133,1105,136,1088,138,1101,142,1079,145,1088,148,1084,151,1075,154,1075,157,1079,161,1066,164,1084,167,1066,170,1062,173,1066,176,1049,179,1053,182,1053,184,1045,187,1053,190,1040,193,1049,195,1045,198,1027,201,1049,204,1027,207,1045,209,1032,212,1032,215,1036,218,1036,220,1036,223,1049,225,1036,227,1036,230,1045,233,1049,235,1049,237,1053,240,1058,242,1049,244,1066,246,997,248,871,250,806,252,806,254,810,256,832,258,845,259,845,260,728,262,724,262,685,261,771,260,793,258,819,255,763,252,750,249,758,246,797,242,815,239,802,235,780,232,758,230,771,226,793,223,815,219,815,215,802,212,789,208,793,205,815,201,806,197,802,194,776,190,780,186,797,182,802,179,815,175,802,172,784,169,802,165,806,161,806,157,797,153,797,150,793,146,793,142,797,138,802,134,797,131,802,127,793,123,802,120,806,117,810,113,802,110,802,106,802,102,793,99,810,95,802,92,810,88,806,85,797,81,810,78,793,75,810,71,823,68,802,66,810,63,793,60,806,57,793,54,819,51,810,48,819,45,819,42,802,39,819,37,810,34,819,32,810,29,823,27,810,24,815,23,819,21,819,19,815,17,815,15,815,13,815,12,815,10,815,9,815,7,806,6,815,5,815,4,819,3,802,2,815,2,797,1,806,1,797,0,858,0,962";
//        data[14] = "0,1424,0,1528,0,1581,0,1676,1,1724,1,1777,2,1746,3,1689,3,1702,4,1724,6,1711,7,1676,8,1668,10,1698,12,1702,13,1689,15,1681,17,1694,19,1694,21,1685,23,1689,26,1685,28,1689,31,1685,34,1681,36,1681,39,1681,41,1681,44,1668,47,1668,49,1659,53,1659,56,1672,59,1672,62,1637,64,1611,67,1624,70,1681,74,1650,77,1611,80,1615,83,1641,86,1633,90,1620,93,1633,95,1637,98,1637,101,1624,105,1620,108,1628,110,1624,113,1633,116,1628,118,1624,121,1633,124,1628,126,1611,128,1624,131,1633,133,1628,135,1624,137,1628,140,1628,142,1628,144,1633,146,1633,148,1637,149,1655,151,1646,153,1628,155,1633,156,1650,158,1646,160,1628,161,1633,163,1637,164,1633,165,1633,167,1637,168,1646,169,1646,170,1650,171,1650,172,1650,173,1646,174,1650,175,1646,176,1659,177,1655,177,1659,178,1659,178,1655,179,1663,179,1650,180,1646,180,1637,181,1641,181,1641,181,1637,181,1576,181,1428,181,1415,181,1402,181,1380,181,1345,180,1319,180,1280,180,1263,179,1223,179,1202,178,1180,178,1141,177,1132,176,1097,175,1071,174,1045,173,1014,172,997,171,979,170,988,168,997,167,984,165,971,164,979,162,993,160,971,158,966,157,971,155,984,153,971,151,958,149,962,147,975,145,971,142,958,140,966,138,962,135,962,133,966,130,958,128,958,125,958,123,953,121,966,118,953,115,945,112,949,109,949,107,949,104,953,101,953,99,953,96,940,93,918,90,949,88,949,84,940,82,949,79,953,76,945,73,923,70,945,68,962,65,936,62,923,59,958,57,949,54,923,52,918,49,940,46,945,44,936,41,927,39,949,37,936,34,936,32,958,29,953,27,949,25,949,23,953,21,958,19,958,17,958,16,971,14,962,12,953,11,971,9,962,8,966,7,958,6,953,4,953,4,975,3,1006,2,1032,1,1067,1,1114,0,1149,0,1193";
//        data[15] = "0,1271,0,1506,0,1533,1,1602,1,1689,2,1746,3,1772,3,1724,4,1685,6,1707,7,1716,9,1685,10,1663,12,1676,14,1694,16,1685,18,1672,20,1681,22,1698,24,1685,27,1681,30,1681,32,1681,35,1681,38,1681,41,1681,44,1676,47,1676,50,1668,53,1668,56,1668,60,1659,63,1650,66,1663,69,1663,73,1611,76,1624,79,1663,82,1659,86,1628,89,1615,92,1650,94,1641,98,1624,101,1628,104,1637,106,1641,109,1641,112,1633,115,1628,117,1628,120,1637,123,1637,125,1637,127,1637,130,1633,132,1633,134,1633,136,1633,139,1646,141,1641,143,1637,145,1637,147,1637,149,1633,151,1637,152,1641,154,1650,156,1650,157,1646,159,1637,161,1650,162,1655,163,1637,165,1633,166,1637,167,1641,169,1637,170,1637,171,1650,172,1650,173,1650,174,1650,175,1655,176,1659,177,1650,177,1650,178,1650,179,1668,179,1663,180,1663,180,1655,181,1650,181,1650,181,1650,182,1641,182,1633,182,1628,182,1628,182,1624,182,1511,182,1411,182,1398,182,1371,182,1354,181,1328,181,1289,180,1258,180,1232,179,1206,179,1175,178,1149,177,1123,176,1101,175,1080,174,1054,173,1023,172,993,171,975,170,966,168,984,167,979,165,958,163,966,162,971,160,975,158,958,156,953,154,971,152,966,150,953,148,949,146,962,144,962,141,949,139,953,137,962,134,953,132,949,129,958,127,949,124,945,122,945,119,953,116,962,114,949,111,932,108,949,105,940,102,940,100,962,97,949,94,945,91,936,88,940,86,962,83,945,80,945,77,962,74,949,72,927,69,932,66,953,63,958,60,932,58,936,55,962,53,940,50,914,47,945,45,945,42,940,40,936,37,923,35,945,33,932,30,936,28,958,26,958,24,940,22,953,20,953,18,953,16,962,14,949,13,962,11,966,10,966,8,953,7,958,6,953,5,953,4,940,3,966,2,984,1,1019,1,1040,1,1084,0,1119,0,1158";
//        data[16] = "0,2668,0,2853,0,2965,1,3000,1,3025,2,3185,3,3258,4,3310,5,3344,7,3379,8,3426,10,3500,12,3478,14,3439,16,3323,18,3112,21,3099,23,3056,26,3025,29,2969,32,2982,35,3038,38,3137,41,3237,45,3297,48,3297,52,3293,56,3280,60,3267,64,3250,68,3185,72,3021,76,2965,81,2892,85,2905,89,2931,94,2974,98,2978,102,3025,107,3125,111,3224,116,3288,120,3344,124,3297,129,3280,133,3224,138,3176,143,3133,147,3064,152,3008,156,2939,161,2943,165,2995,170,3017,174,3129,178,3172,182,3198,187,3237,191,3280,195,3323,199,3314,203,3250,207,3168,211,3090,214,3064,218,3034,222,3021,225,3017,229,2969,233,2978,236,3064,239,3125,242,3189,246,3202,249,3219,252,3163,254,3168,257,3241,260,3202,262,3133,265,3038,267,2982,269,2987,272,2948,274,3000,276,3004,278,2943,280,2974,281,3021,283,3133,285,3176,286,3155,287,3163,288,3103,289,3081,290,3103,291,3090,291,3012,292,2961,292,2952,292,2935,292,2956,292,3008,292,3008,292,2991,292,2952,291,2987,290,3000,289,2896,288,2762,287,2478,286,2099,285,1594,283,1439,281,1409,279,1353,278,1327,275,1344,273,1344,271,1400,269,1431,266,1331,263,1228,260,1288,258,1379,254,1461,251,1517,248,1625,245,1637,241,1659,238,1702,234,1788,231,1780,227,1780,223,1681,219,1594,215,1573,211,1599,206,1586,202,1603,198,1607,194,1616,190,1672,185,1728,181,1806,176,1840,172,1810,168,1801,163,1793,158,1788,154,1793,149,1762,145,1737,140,1689,136,1646,131,1659,127,1698,122,1711,118,1724,113,1754,109,1775,104,1797,100,1879,96,1887,92,1887,87,1836,83,1801,79,1801,75,1775,71,1780,67,1793,63,1750,59,1767,56,1758,52,1806,48,1836,45,1857,42,1883,38,1896,35,1887,32,1913,29,1935,26,1943,24,1926,21,1900,19,1900,16,1913,14,1918,12,1926,10,1939,9,1952,7,1952,6,2021,4,2043,3,2081,2,2094,1,2125,1,2172,0,2237,0,2366";
//        data[17] = "0,2607,0,2646,0,2642,1,2642,1,2612,2,2702,3,2810,4,2922,5,3004,7,3060,8,3068,10,2991,12,2965,14,2952,16,2887,18,2741,21,2637,23,2551,26,2521,29,2500,32,2560,35,2633,38,2642,41,2693,45,2810,48,2900,52,2948,56,2943,60,2952,64,2883,68,2750,72,2741,76,2693,81,2599,85,2521,89,2491,94,2512,98,2521,102,2603,107,2732,111,2771,116,2801,120,2862,124,2909,129,2918,133,2870,138,2853,143,2784,147,2646,152,2616,156,2607,161,2581,165,2577,170,2564,174,2612,178,2642,182,2685,187,2806,191,2844,195,2853,199,2831,203,2581,207,2568,211,2590,214,2637,218,2650,222,2801,225,2827,229,2857,233,2840,236,2801,239,2762,242,2750,246,2706,249,2668,252,2543,254,2512,257,2465,260,2482,262,2525,265,2573,267,2577,269,2594,272,2616,274,2698,276,2711,278,2745,280,2693,281,2650,283,2577,285,2547,286,2534,287,2500,288,2413,289,2396,290,2366,291,2396,291,2443,292,2504,292,2517,292,2525,292,2525,292,2564,292,2560,292,2556,292,2521,291,2452,290,2353,289,2314,288,2288,287,2267,286,2237,285,2206,283,2176,281,2155,279,2168,278,2228,275,2254,273,2254,271,2228,269,2219,266,2086,263,1969,260,1840,258,1698,254,1586,251,1590,248,1642,245,1711,241,1771,238,1935,234,2034,231,2129,227,2232,223,2340,219,2331,215,2293,211,2232,206,2176,202,2099,198,2043,194,1991,190,1974,185,1892,181,1926,176,2034,172,2094,168,2168,163,2267,158,2314,154,2318,149,2323,145,2422,140,2392,136,2327,131,2271,127,2219,122,2168,118,2150,113,2172,109,2193,104,2189,100,2215,96,2271,92,2323,87,2396,83,2426,79,2452,75,2452,71,2431,67,2409,63,2409,59,2387,56,2336,52,2314,48,2301,45,2306,42,2336,38,2357,35,2400,32,2418,29,2448,26,2491,24,2530,21,2547,19,2551,16,2538,14,2525,12,2500,10,2482,9,2478,7,2478,6,2439,4,2452,3,2448,2,2482,1,2500,1,2525,0,2560,0,2581";
//        data[18] = "0,614,0,753,0,840,0,857,0,827,0,835,1,943,1,956,1,1000,2,1039,2,1021,3,939,3,956,4,961,5,1021,5,1013,6,974,7,952,8,948,9,961,10,969,10,978,12,956,13,943,14,939,15,956,16,961,18,952,19,943,20,939,21,943,23,952,24,939,25,931,27,931,28,931,29,935,31,931,33,926,34,926,36,922,37,922,39,935,40,943,41,935,43,913,45,909,47,913,48,922,49,913,51,922,52,909,54,905,55,909,56,913,58,922,59,909,61,913,63,900,64,905,66,909,67,905,68,900,69,887,70,900,72,896,73,900,74,900,76,892,77,887,78,887,79,892,80,892,81,896,82,892,84,883,84,892,85,892,86,892,87,892,88,879,89,883,89,887,90,883,91,879,91,887,92,879,93,879,93,887,94,874,94,883,94,879,95,879,95,883,95,892,96,887,96,892,96,900,96,909,96,905,96,861,96,753,96,744,96,757,96,740,96,714,96,692,96,658,96,614,95,567,95,536,95,571,94,601,94,614,94,575,93,554,93,554,92,571,92,593,91,588,90,567,90,558,89,554,89,584,88,584,87,575,86,562,85,554,85,562,83,575,83,580,82,562,81,558,80,549,79,567,78,580,77,571,75,571,74,545,73,558,72,567,71,580,69,562,68,554,67,549,66,554,64,571,63,558,61,567,60,545,58,541,57,554,56,554,54,562,53,558,51,549,50,536,48,549,47,545,45,554,43,541,42,532,41,541,39,536,37,545,35,545,34,549,33,536,31,532,29,541,28,545,26,549,25,532,23,541,22,549,20,554,19,562,18,562,16,558,15,558,14,554,13,554,12,554,10,549,9,554,8,545,7,554,7,567,5,562,5,575,4,562,3,571,3,575,2,584,2,584,1,593,1,593,1,593,0,601,0,593";
//        data[19] = "0,723,0,814,0,861,0,831,0,831,1,935,1,952,1,987,2,1017,2,1004,3,922,3,952,4,961,4,1008,5,995,6,982,7,939,7,948,9,961,9,969,10,969,12,935,12,935,14,939,15,952,16,956,17,943,18,935,20,935,21,939,22,943,24,939,25,926,27,931,28,931,29,948,31,935,32,926,34,922,35,931,37,939,39,935,40,931,42,918,43,913,44,918,46,918,47,926,49,918,51,913,52,896,54,909,55,913,57,905,58,918,59,896,61,900,62,896,64,900,65,913,66,900,68,905,69,887,70,892,72,892,73,905,75,900,76,883,77,883,78,883,79,892,80,883,81,892,82,879,83,874,84,887,85,883,86,892,87,879,88,879,89,874,90,874,90,879,91,874,92,874,92,870,93,870,93,866,94,874,94,874,95,874,95,874,95,879,96,874,96,879,96,883,96,887,97,896,97,900,97,900,97,848,97,762,97,749,97,753,97,731,96,710,96,688,96,649,96,610,96,554,95,536,95,571,94,610,94,610,94,567,93,554,93,545,92,584,92,606,91,584,90,575,90,554,89,567,88,575,87,593,86,571,86,567,85,562,84,562,83,593,82,584,81,580,80,562,79,562,78,584,77,571,76,580,75,571,74,567,73,567,71,567,70,562,69,562,68,567,66,558,65,567,64,562,62,558,61,562,59,558,58,562,56,562,55,554,53,554,52,558,50,554,49,562,47,562,46,545,44,554,42,532,41,549,39,549,38,549,36,549,34,545,33,545,31,541,30,558,29,554,27,554,26,541,24,541,23,558,21,558,20,571,18,567,17,562,16,554,14,567,13,567,12,567,11,562,10,554,9,558,8,558,7,575,6,571,5,584,4,580,4,580,3,584,3,597,2,601,1,601,1,606,1,606,1,606,0,606,0,606";
//        data[20] = "0,1942,0,1916,0,1994,0,2050,1,2084,1,2101,2,2131,3,2161,4,2312,5,2424,6,2475,7,2518,8,2570,10,2613,12,2712,13,2720,15,2703,17,2690,19,2651,22,2617,24,2583,27,2574,29,2595,32,2613,34,2626,36,2664,39,2677,42,2677,45,2643,48,2634,51,2591,54,2565,57,2561,60,2565,63,2578,66,2600,68,2613,71,2634,74,2643,77,2664,80,2630,83,2595,86,2561,89,2518,92,2527,95,2540,98,2574,100,2583,103,2608,106,2617,108,2617,111,2608,114,2583,117,2501,119,2505,122,2492,124,2488,126,2475,129,2492,130,2570,133,2570,135,2548,137,2557,139,2544,141,2544,143,2484,145,2471,147,2492,149,2484,150,2497,152,2527,153,2561,155,2583,157,2561,158,2548,159,2544,161,2510,162,2488,164,2479,165,2488,166,2505,167,2505,168,2544,169,2553,170,2557,171,2540,172,2527,173,2518,173,2505,174,2488,175,2488,175,2510,176,2510,176,2522,176,2522,177,2548,177,2522,177,2522,177,2497,178,2488,178,2411,178,2398,177,2402,177,2398,177,2406,177,2385,177,2415,176,2411,176,2402,175,2402,175,2393,174,2398,173,2385,172,2381,171,2389,170,2389,169,2398,168,2385,167,2385,166,2393,165,2376,163,2363,162,2351,160,2363,158,2363,157,2355,155,2363,153,2372,151,2381,149,2372,148,2389,146,2376,144,2372,142,2355,139,2346,137,2368,134,2363,132,2363,130,2368,127,2376,125,2368,122,2363,120,2346,118,2346,115,2342,112,2333,109,2351,107,2338,104,2355,101,2342,98,2351,96,2346,93,2342,91,2346,88,2329,85,2351,82,2346,80,2355,77,2359,74,2368,71,2376,68,2372,66,2363,63,2363,60,2368,58,2363,55,2355,53,2363,50,2355,47,2342,45,2333,42,2320,40,2273,37,2222,35,2161,33,2071,30,1946,29,1865,27,1770,24,1680,23,1616,20,1538,18,1633,17,1753,15,1813,13,1878,12,1916,10,1925,9,1878,8,1813,6,1770,5,1736,4,1732,3,1740,3,1796,2,1882,1,1904,1,1942,0,1934,0,1964";
//        data[21] = "0,1916,0,1989,0,2037,0,2032,1,2020,1,2020,2,2110,3,2204,4,2277,4,2312,6,2346,7,2406,9,2574,10,2690,12,2767,14,2785,15,2776,17,2750,19,2669,21,2574,24,2514,26,2510,29,2527,31,2570,34,2626,37,2699,40,2712,42,2720,45,2694,47,2660,51,2587,54,2527,57,2501,60,2510,63,2540,66,2578,69,2617,72,2643,75,2660,78,2677,81,2660,84,2587,87,2527,90,2488,93,2488,96,2510,99,2561,101,2600,104,2647,107,2660,110,2643,111,2638,114,2600,117,2544,119,2436,122,2467,124,2458,127,2454,129,2479,131,2570,134,2630,136,2578,138,2578,140,2565,142,2531,144,2497,146,2445,147,2454,149,2492,151,2484,153,2535,154,2578,156,2604,157,2591,159,2540,160,2544,161,2505,163,2479,164,2454,165,2467,167,2514,168,2510,169,2544,170,2570,171,2583,172,2548,172,2535,173,2518,174,2492,175,2467,175,2479,176,2475,176,2522,177,2527,177,2544,177,2557,178,2535,178,2531,178,2510,178,2492,178,2415,178,2402,178,2398,178,2398,178,2411,178,2402,177,2415,177,2419,176,2406,176,2393,175,2376,175,2381,174,2372,173,2363,172,2389,171,2389,170,2389,169,2389,168,2381,167,2381,165,2359,164,2355,163,2351,161,2342,159,2346,158,2351,156,2355,154,2359,152,2381,150,2381,148,2393,146,2368,144,2355,142,2338,140,2346,138,2359,135,2363,133,2363,131,2372,128,2376,126,2359,123,2359,120,2351,118,2346,115,2329,113,2325,110,2351,108,2346,105,2351,102,2346,99,2346,96,2346,94,2329,91,2325,88,2329,85,2338,82,2338,80,2342,78,2346,75,2355,72,2351,69,2351,66,2351,63,2338,60,2329,58,2320,55,2308,52,2282,50,2239,48,2191,45,2093,43,1951,40,1779,38,1654,35,1555,33,1500,31,1542,29,1680,26,1809,24,1882,22,1929,21,1929,19,1916,17,1843,15,1740,13,1693,12,1667,10,1680,9,1732,7,1813,6,1908,5,1921,4,1934,3,1912,3,1878,2,1830,1,1757,1,1762,0,1787,0,1822";
//        data[22] = "0,1021,0,1039,0,1056,0,1086,0,1086,0,1082,1,1103,1,1306,1,1375,2,1392,2,1422,3,1388,3,1366,4,1353,5,1349,6,1379,7,1384,7,1388,8,1375,9,1371,10,1371,11,1362,12,1362,13,1349,14,1353,15,1358,17,1345,18,1358,19,1349,20,1340,22,1332,23,1323,24,1327,26,1336,28,1349,28,1353,30,1358,31,1353,33,1349,35,1349,36,1349,37,1353,38,1358,40,1358,42,1345,43,1345,45,1340,46,1336,47,1336,49,1340,50,1319,52,1306,54,1284,55,1293,57,1284,57,1284,59,1280,61,1271,62,1276,64,1280,64,1280,66,1284,68,1280,69,1284,70,1280,71,1284,72,1284,74,1276,75,1276,76,1271,77,1267,78,1267,80,1267,80,1258,81,1254,83,1233,83,1233,84,1220,85,1215,86,1207,87,1198,87,1189,88,1181,89,1177,90,1172,90,1172,91,1172,91,1164,92,1164,92,1164,93,1155,93,1159,94,1146,94,1138,94,1142,94,1133,94,1133,95,1129,95,1112,95,1090,95,1056,95,1056,95,1034,95,1021,95,1017,95,987,95,957,94,896,94,836,94,814,94,732,94,689,93,711,93,745,92,763,92,771,91,741,91,720,90,694,90,689,89,711,88,715,88,720,87,707,86,698,86,681,85,668,84,672,83,676,82,681,81,668,80,663,80,655,78,659,77,651,76,655,75,659,74,655,73,659,72,651,71,659,69,663,69,668,67,663,65,668,65,672,63,676,62,668,60,672,59,663,58,659,56,663,54,668,53,668,52,663,51,668,49,663,47,663,46,668,44,672,43,663,41,663,39,668,38,659,36,668,35,672,34,676,32,689,31,685,29,689,28,689,26,698,24,707,23,707,21,707,20,715,19,715,17,724,16,732,15,728,13,728,12,724,11,737,10,737,9,737,8,737,7,732,6,741,6,741,5,750,4,750,3,750,3,763,2,767,2,776,1,793,1,797,1,823,0,853,0,905";
//        data[23] = "0,1039,0,1056,0,1086,0,1082,0,1082,1,1159,1,1284,1,1379,2,1414,2,1440,3,1401,4,1379,4,1362,5,1375,5,1384,6,1396,7,1401,8,1392,9,1392,10,1379,11,1371,12,1362,13,1362,14,1362,15,1366,16,1371,18,1366,19,1371,20,1353,22,1336,23,1340,24,1366,25,1371,27,1375,29,1375,29,1371,31,1358,32,1358,34,1358,36,1366,37,1362,38,1366,39,1362,41,1349,43,1340,44,1340,46,1345,47,1349,48,1327,50,1302,51,1297,53,1297,55,1310,56,1306,57,1310,58,1302,60,1293,62,1297,63,1297,64,1289,65,1293,67,1293,68,1284,69,1284,71,1284,71,1284,73,1280,74,1267,75,1267,77,1263,78,1263,79,1263,80,1258,81,1250,82,1233,83,1220,83,1220,85,1220,85,1215,86,1215,87,1211,88,1202,88,1189,89,1185,90,1185,90,1185,91,1181,91,1168,92,1177,92,1168,93,1155,93,1155,93,1155,94,1142,94,1146,94,1133,94,1133,94,1125,94,1073,94,1060,94,1052,94,1043,94,1026,94,1013,94,1004,94,961,94,918,94,866,94,806,93,763,93,694,93,715,92,732,92,771,91,780,91,758,90,724,90,707,89,698,89,702,88,711,87,720,87,724,86,698,85,698,84,681,83,676,83,685,82,685,81,681,80,672,79,668,78,663,77,668,76,668,75,668,74,659,73,659,72,655,70,655,69,655,68,646,67,651,66,655,64,655,63,651,62,655,61,659,59,663,57,659,56,659,55,659,53,663,52,659,50,663,49,659,47,663,45,663,45,663,43,663,42,655,40,655,38,659,37,659,35,672,34,672,32,676,30,676,29,681,27,685,26,689,25,702,23,702,22,702,20,707,19,711,18,720,16,724,15,724,14,724,12,728,12,728,10,724,10,728,8,728,7,728,7,732,6,741,5,750,4,745,3,745,3,754,2,754,1,776,1,784,1,806,1,823,0,845,0,935,0,1000";
//
//        for(int x = 0; x < data.length; x++) {
//            List<List<Double>> nn  = SGTUtil.encodeToUseList((String) data[x]);
//            System.out.println(nn);
//        }

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String date ="2021-12-30";
        Date dt = sdf.parse(date);

        Calendar rightNow = Calendar.getInstance();
        rightNow.setTime(dt);
        rightNow.add(Calendar.DATE, -1);
        Date dt1 = rightNow.getTime();
        String reStr = sdf.format(dt1);
        List<AoidDailyYield> JJ = aoidDailyYieldService.getCalErrorRateByDateToday(reStr);
        System.out.println(JJ.size());



    }

    //计算绝对值
    public static double abs(double A2, double xtyl) {
        if(A2>xtyl){
            return A2-xtyl;
        }else{
            return xtyl-A2;
        }

    }
    //保留2位有效数字
    public static double round2(double in) {
        DecimalFormat df   = new DecimalFormat("######0.00");
        return Double.valueOf(df.format(in));
    }


}