package com.gct.aoid.algorithm;

import java.lang.reflect.InvocationTargetException;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.format.DateTimeFormatter;
import java.util.*;

import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.ProductionCalApplication;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.job.properties.JobParamConfigurationProperties;
import com.gct.aoid.job.properties.MutableJobConfigProperties;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.aoid.service.AoidSinglegtYieldService;
//import com.gct.aoid.service.YieldErrorAnalysisService;
//import com.gct.aoid.service.impl.CalibrationParameterService;
//import com.gct.aoid.service.impl.YieldErrorAnalysisCalculationService;
import com.gct.aoid.service.LiqProdDailyCalService;
import com.gct.common.core.result.Result;
import com.gct.common.util.DateTimeUtil;
import com.gct.common.util.SGTUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;
//
@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class testdata {


    @Autowired
    private BaseDataClient baseDataClient;
////
//    @Autowired
//    private AoidDailyYieldService aoidDailyYieldService;
//
//    @Autowired
//    private YieldErrorAnalysisCalculationService yieldErrorAnalysisCalculationService;
//
//    @Autowired
//    private YieldErrorAnalysisService yieldErrorAnalysisService;
//
//
//    @Autowired
//    private CalibrationParameterService calibrationParameterService;
//


    @Autowired
    public LiqProdDailyCalService service;
    @Autowired
    MutableJobConfigProperties config;
    public static ThreadLocal<Boolean> threadLocal = new ThreadLocal<Boolean>();

    private final DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
    private final DateTimeFormatter dfValue = DateTimeFormatter.ofPattern("yyyy-MM-dd");




    @Test
    public void testSingle() throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException, ParseException {


//
//
//
//
//        String dateValue =  LocalDateTime.parse(date,df).minusDays(2).format(dfValue)+" "+timeValue;
//        System.out.println("测试时间："+dateValue);
//        System.out.println("测试时间1："+date);
//        System.out.println("测试时间："+dateValue.length());
//        System.out.println("测试时间1："+date.length());


    }

    //保留2位有效数字
    public static double round2(double in) {
        DecimalFormat df   = new DecimalFormat("######0.00");
        return Double.valueOf(df.format(in));
    }

    private int getDifferHour(Date startDate, Date endDate) {
        long dayM = 1000 * 24 * 60 * 60;
        long hourM = 1000 * 60 * 60;
        long differ = endDate.getTime() - startDate.getTime();
        long hour = differ % dayM / hourM;
        return Integer.parseInt(String.valueOf(hour));
    }
//
//
//    //获取动态参数数据
//    public DynamicParam getDynamicParam(String wellId, String dateStart, String dateEnd)
//    {
//        DynamicParam dynamicParam = new DynamicParam();
//        double sumYxccYesterday =0.0;
//        double sumBzxsYesterday =0.0;
//        double sumLoadDifference =0.0;
//        double sumArea=0.0;
//        double sumStroke=0.0;
//        double sumfrequence=0.0;
//        double AreaAvg =0.0;
//        double YxccYesterdayAvg =0.0;
//        double BdxsYesterdayAvg =0.0;
//        double LoadDifferenceAvg =0.0;
//        double strokeAvg=0.0;
//        double frequenceAvg=0.0;
//        System.out.println("dateStart---"+dateStart);
//        System.out.println("dateEnd---"+dateEnd);
//        List<AoidSinglegtYield> resultZdjg = aoidSinglegtYieldService.findByJhbasecs(wellId,dateStart,dateEnd);
//        System.out.println("resultZdjg-----"+resultZdjg);
//        System.out.println("resultZdjgsize-----"+resultZdjg.size());
//        if (resultZdjg.size()!=0) {
//            for (int y = 0; y < resultZdjg.size(); y++) {
//
//                double sxzh = resultZdjg.get(y).getSxzh() == null ? 0 : resultZdjg.get(y).getSxzh();
//                double xxzh = resultZdjg.get(y).getXxzh() == null ? 0 : resultZdjg.get(y).getXxzh();
//                sumYxccYesterday += resultZdjg.get(y).getYxcc() == null ? 0 : resultZdjg.get(y).getYxcc();
//                sumBzxsYesterday += resultZdjg.get(y).getBdxs() > 9 ? 1 : resultZdjg.get(y).getBdxs();
//                List<List<Double>> sgtList = new ArrayList<>();
//                if (Objects.nonNull(resultZdjg.get(y).getSgt())) {
//                    sgtList = SGTUtil.encodeToUseList((String) resultZdjg.get(y).getSgt());
//                    if (Objects.nonNull(sgtList) && sgtList.size() > 1) {
//                        sgtList.remove(sgtList.size() - 1);
//                        sgtList.add(sgtList.get(0));
//                    }
//                    Double[][] sgtValue = JSONObject.parseObject(sgtList.toString(), Double[][].class);
//                    sumArea += CardAreaAlgorithm.calArea(sgtValue);
//                }
//                sumLoadDifference += sxzh - xxzh;
//                sumStroke += resultZdjg.get(y).getStroke() == null ? 0 : resultZdjg.get(y).getStroke();
//                sumfrequence += resultZdjg.get(y).getFrequence() == null ? 0 : resultZdjg.get(y).getFrequence();
//            }
//            YxccYesterdayAvg = sumYxccYesterday / resultZdjg.size();
//            BdxsYesterdayAvg = sumBzxsYesterday / resultZdjg.size();
//            LoadDifferenceAvg = sumLoadDifference / resultZdjg.size();
//            AreaAvg = sumArea / resultZdjg.size();
//            strokeAvg = sumStroke/resultZdjg.size();
//            frequenceAvg = sumfrequence/resultZdjg.size();
//            dynamicParam.yxcc = YxccYesterdayAvg;
//            dynamicParam.LoadDifference = LoadDifferenceAvg;
//            dynamicParam.area = AreaAvg;
//            dynamicParam.bdxs = BdxsYesterdayAvg;
//            dynamicParam.stroke = strokeAvg;
//            dynamicParam.frequence = frequenceAvg;
//        }
//
//
//        return dynamicParam;
//    }
//


    //动态参数类
    public class DynamicParam
    {
        private Double yxcc;
        private Double LoadDifference;
        private Double area;
        private Double bdxs;
        private Double stroke;
        private Double frequence;
    }


    //示功图面积算法
    public double getParamFromGT(Double[][] gt) {
        double s = 0;
        double sEffect = 0;
        for (int i = 0; i < gt.length / 2 - 1; i++) {
            double h = Math.abs(gt[i][0] - gt[i + 1][0]);
            double Si = (gt[i][1] + gt[i + 1][1]) * h / 2.0;
            s += Si;
        }
        for (int i = gt.length / 2 - 1; i < gt.length - 1; i++) {
            if (gt[i][1] - gt[0][1] < 0.1 && sEffect == 0) {
                sEffect = Math.abs(gt[i][0] - gt[0][0]);
            }
            double h = Math.abs(gt[i][0] - gt[i + 1][0]);
            double Si = (gt[i][1] + gt[i + 1][1]) * h / 2.0;
            s -= Si;
        }

        return s;
    }


    public static void main(String[] args) throws Exception {
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd");
        Date time = simpleDateFormat.parse("2020-01-03");

        Calendar calendar = Calendar.getInstance();
        calendar.setTime(time);

        int year = calendar.get(Calendar.YEAR);
        int month = calendar.get(Calendar.MONTH) + 1;
        int day = calendar.get(Calendar.DAY_OF_MONTH);

        String monthValue = month >= 10 ? String.valueOf(month) : "0" + month;
        String dayValue = day >= 10 ? String.valueOf(day) : "0" + day;

        System.out.println(year);
        System.out.printf("当前月份：%s，当前几号：%s%n", month, day);

        // 方法一：
        System.out.printf("当前月份：%s，当前几号：%s%n", month >= 10 ? month : "0" + month, day > 10 ? day : "0" + day);

        String jj= String.valueOf(year)+'-'+monthValue+'-'+dayValue;
        System.out.println("测试日期："+jj);
        // 方法二：
        // StringUtils.leftPad() 左侧补齐 第一个参数：原始字符串，第二个参数：字符串的长度，第三个是补充的字符串
        String normalizeMonth = StringUtils.leftPad(String.valueOf(calendar.get(Calendar.MONTH) + 1), 2, '0');
        String normalizeDay = StringUtils.leftPad(String.valueOf(calendar.get(Calendar.DAY_OF_MONTH)), 2, '0');
        System.out.printf("当前月份：%s，当前几号：%s%n", normalizeMonth, normalizeDay);
    }


    public static List findDates(String dBegin, String dEnd) throws ParseException, java.text.ParseException {

//日期工具类准备

        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");

//设置开始时间

        Calendar calBegin = Calendar.getInstance();

        calBegin.setTime(format.parse(dBegin));

//设置结束时间

        Calendar calEnd = Calendar.getInstance();

        calEnd.setTime(format.parse(dEnd));

//装返回的日期集合容器

        List Datelist = new ArrayList();

//将第一个月添加里面去

        Datelist.add(format.format(calBegin.getTime()));

// 每次循环给calBegin日期加一天，直到calBegin.getTime()时间等于dEnd

        while (format.parse(dEnd).after(calBegin.getTime())) {

// 根据日历的规则，为给定的日历字段添加或减去指定的时间量

            calBegin.add(Calendar.DAY_OF_MONTH, 1);

            Datelist.add(format.format(calBegin.getTime()));

        }

        System.out.println(Datelist);

        return Datelist;

    }

//    //获取A2基础数据
//    public A2Basedata getA2Basedata(String wellId, String A2ProdDate)throws InvocationTargetException, IllegalAccessException, InstantiationException, NoSuchMethodException
//    {
//
//        String A2ProdDateValue = A2ProdDate+" 00:00:00";
//
//        A2Basedata a2Basedata = new A2Basedata();
//        ProDataForCalProduction a2DataVolYesterday;
//        ProDataForCalProduction a2DataStatusYesterday;
//
//
//        String a2dataStrVolYesterday = baseDataClient.getA2VolDataForCalProduction(wellId, A2ProdDateValue);
//        a2DataVolYesterday = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrVolYesterday, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
//
//        String a2dataStrYesterday = baseDataClient.getA2StatusDataForCalProduction(wellId, A2ProdDateValue);
//        a2DataStatusYesterday = (ProDataForCalProduction) JSONObject.parseObject(a2dataStrYesterday, Result.class).toFiguredOutObject(ProDataForCalProduction.class);
//
//
//        if (a2DataVolYesterday!=null)
//        {
//
//
//            a2Basedata.a2bj=(a2DataStatusYesterday.getBj()==null)?0:a2DataStatusYesterday.getBj();
//
//            a2Basedata.a2bs=(a2DataStatusYesterday.getBs()==null)?0:a2DataStatusYesterday.getBs();
//
//            a2Basedata.a2hsl=(a2DataVolYesterday.getHsl()==null)?0:a2DataVolYesterday.getHsl();
//
//            a2Basedata.a2qyb=(a2DataVolYesterday.getQyb()==null)?0:a2DataVolYesterday.getQyb();
//
//            a2Basedata.a2dym=(a2DataStatusYesterday.getDym()==null)?0:a2DataStatusYesterday.getDym();
//
//            a2Basedata.a2ymd=(a2DataVolYesterday.getYmd()==null)?0:a2DataVolYesterday.getYmd();
//
//            a2Basedata.a2smd=(a2DataVolYesterday.getSmd()==null)?0:a2DataVolYesterday.getSmd();
//
//
//
//            a2Basedata.a2backPres=(a2DataStatusYesterday.getBackPres()==null)?0:a2DataStatusYesterday.getBackPres();
//            a2Basedata.a2tubingPres=(a2DataStatusYesterday.getTubingPres()==null)?0:a2DataStatusYesterday.getTubingPres();
//            a2Basedata.a2casingPres=(a2DataStatusYesterday.getCasingPres()==null)?0:a2DataStatusYesterday.getCasingPres();
//
//
//            if (Objects.nonNull(a2DataStatusYesterday.getBs()) && Objects.nonNull(a2DataStatusYesterday.getDym()))
//            {
//                a2Basedata.a2cmd= Math.abs(a2DataStatusYesterday.getBs().doubleValue()-a2DataStatusYesterday.getDym().doubleValue());
//            }
//
//
//            a2Basedata.a2liqProdDaily=(a2DataVolYesterday.getLiqProdDaily()==null)?0:a2DataVolYesterday.getLiqProdDaily();
//            a2Basedata.a2oilProdDaily=(a2DataVolYesterday.getOilProdDaily()==null)?0:a2DataVolYesterday.getOilProdDaily();
//            a2Basedata.a2waterProdDaily=(a2DataVolYesterday.getWaterProdDaily()==null)?0:a2DataVolYesterday.getWaterProdDaily();
//            a2Basedata.a2gasProdDaily=(a2DataVolYesterday.getGasProdDaily()==null)?0:a2DataVolYesterday.getGasProdDaily();
//
//            a2Basedata.a2remarks=a2DataVolYesterday.getRemarks();
//            a2Basedata.a2prodTime=a2DataVolYesterday.getProdTime();
//        }
//
//        return a2Basedata;
//    }
//
//


    //A2基础数据类
    public class A2Basedata
    {
        private Double a2bj;

        private Double a2bs;

        private Double a2hsl;

        private Double a2qyb;

        private Double a2dym;

        private Double a2ymd;

        private Double a2smd;

        private String a2proDate;


        private Double a2backPres;
        private Double a2tubingPres;
        private Double a2casingPres;


        private Double a2cmd;

        private Double a2liqProdDaily;
        private Double a2oilProdDaily;
        private Double a2waterProdDaily;
        private Double a2gasProdDaily;

        private String a2remarks;
        private Integer a2prodTime;


    }


}
