package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gct.aoid.ProductionCalApplication;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.AoidSinglegtYield;

import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.common.util.DateTimeUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.*;
import java.nio.charset.StandardCharsets;
import java.sql.Wrapper;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CountDownLatch;

//import org.junit.jupiter.api.Test;// Don't use the @Test that in the package

@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class AoidSinglegtYieldServiceImplTest {

    @Autowired
    public AoidSinglegtYieldService aoidSinglegtYieldService;


    @Test
    public void test() {//test error  2021.1.25 19:17
        log.info("start to test");
        String jh = "H1348";
        List<AoidSinglegtYield> hh = aoidSinglegtYieldService.findByJh(jh);
        log.info("test successfully {}", hh);

        return;
    }

    @Test
    public void test2() throws InterruptedException {
        CountDownLatch countDownLatch = new CountDownLatch(9);
        LocalDate localDate = DateTimeUtil.formatDate("2022-08-17");
        for (int i = 0; i < 9; i++) {
            int finalI = i;
            new Thread(() -> {
            try {
                int size = 0;
                File file = new File("/home/lloyd/Downloads/test/singlegt" + localDate.plusDays(finalI) + ".txt");
                FileInputStream fis = new FileInputStream(file);
                InputStreamReader isr = new InputStreamReader(fis, StandardCharsets.UTF_8);
                BufferedReader br = new BufferedReader(isr);
                List<AoidSinglegtYield> parseObject = new ArrayList<>();
                char[] buff = new char[2048];
                int byteCount = br.read(buff, 0, 2048);
                String line = "";
                line += new String(buff, 0, byteCount);
                System.out.println(line);
                line = line.substring(1);
                while ((byteCount = br.read(buff, 0, 2048)) > 0) {
                    line += new String(buff, 0, byteCount);
                    int index = -1;
                    while (((index = line.indexOf("},{")) >= 0)) {
                        String temp = line.substring(0, index + 1);
                        line = line.substring(index + 2);
                        parseObject.add(JSONObject.parseObject(temp, AoidSinglegtYield.class));
                    }
                    if (parseObject.size() >= 100) {
                        size += parseObject.size();
                        aoidSinglegtYieldService.saveBatch(parseObject);
                        parseObject.clear();
                    }
                }
                line = line.substring(0, line.length() - 1);
                parseObject.add(JSONObject.parseObject(line, AoidSinglegtYield.class));
                size += parseObject.size();
                aoidSinglegtYieldService.saveBatch(parseObject);
                br.close();
                isr.close();
                fis.close();
                System.out.println("ok = " + file.getAbsoluteFile() + "  num =" + size);
                countDownLatch.countDown();
            } catch (IOException e) {
                e.printStackTrace();
            }
            }).start();
        }
        countDownLatch.await();
    }


}