package com.gct.aoid.controller;


import com.gct.aoid.entity.Vo.SaveThresholdVo;
import com.gct.aoid.service.AoidLiquidThresholdService;
import com.gct.common.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 液量异常阈值设置 前端控制器
 * </p>
 *
 * @author gxt
 * @since 2022-08-15
 */
@RestController
@RequestMapping("/aoidLiquidThreshold")
public class AoidLiquidThresholdController {

    @Autowired
    AoidLiquidThresholdService aoidLiquidThresholdService;

    @GetMapping("/getThresholdList")
    public Result getThresholdList(@RequestParam("appertain") String appertain){
        return Result.ok(aoidLiquidThresholdService.getThresholdList(appertain));
    }

    @PostMapping("/saveThresholdList")
    public Result saveThresholdList(@RequestBody SaveThresholdVo saveThresholdVo){
        return Result.ok(aoidLiquidThresholdService.saveThresholdList(saveThresholdVo));
    }
}

