package com.gct.aoid.entity.MQ;

import io.swagger.annotations.ApiModel;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * class name: SaveTempData
 *
 * @author gxt
 * @version 1.0
 * @since 2022/9/23 下午4:44 周五
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="SaveTempData对象", description="保存请求使用的临时对象")
public class SaveTempData {

    private double finalCoefficient = 1.0;
    private double loadDifference = 0;
    private double area = 0;
    private LocalDateTime prodDateForA2 = null;
    private double ratio = 0;
    private double liqProdDailyForA2 = 0;
    private double validStroke = 0;
    private double loadDifferenceForAvg = 0;
    private double areaForAvg = 0;
    private double yxccRate = 0;
    private double loadDifferenceRate=0;
    private double areaRate = 0;
    private String measures = null;
    private String isStop = null;
    private String parmExplain =null;
    private String parmFlag =null;
}
