package com.gct.aoid.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.gct.aoid.entity.YieldErrorAnalysis;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;


/**
 * @Author: Jyx
 * @Since: 2021/1/28 22:23
 */
@Mapper
public interface YieldErrorAnalysisMapper extends BaseMapper<YieldErrorAnalysis> {


    IPage<YieldErrorAnalysis> findWellWc(IPage<?> page,
                                     @Param("zyq") String zyq,
                                     @Param("wcStart") Double wcStart,
                                     @Param("wcEnd") Double wcEnd,
                                     @Param("cylStart") Double cylStart,
                                     @Param("cylEnd") Double cylEnd,
                                     @Param("dateStart") String dateStart,
                                     @Param("dateEnd") String dateEnd);

    IPage<YieldErrorAnalysis> findWellWcJhvalue(IPage<?> page,
                                            @Param("wcStart") Double wcStart,
                                            @Param("wcEnd") Double wcEnd,
                                            @Param("cylStart") Double cylStart,
                                            @Param("cylEnd") Double cylEnd,
                                            @Param("jh") String jh,
                                            @Param("dateStart") String dateStart,
                                            @Param("dateEnd") String dateEnd);



}
